public class Mutator {
  float[] previous;
  int[] pIdx;
  float precision;
  float limit;
  Mutator(int size, float precision, float limit) {
    previous = new float[size];
    pIdx = new int[size];
    this.precision = precision;
    this.limit = limit;
  }
  void mutate(float[] vec) {
    for (int i = 0; i < previous.length; i++) {
      int rpos = (int)(Math.random()*vec.length);
      float v = vec[rpos];
      pIdx[i] = rpos;
      previous[i] = v;
      float m = 2 * limit * (float)Math.exp(-precision*Math.random());
      if (Math.random() < 0.5) m = -m;
      float vm = v + m;
      if (vm >= limit) vm = v;
      if (vm <= -limit) vm = v;
      vec[rpos] = vm;
    }
  }
  void undo(float[] vec) {
    for (int i = previous.length - 1; i >= 0; i--) {
      vec[pIdx[i]] = previous[i];
    }
  }
}
